# Method: projects.locations.integrations.versions.testCases.upload

- [HTTP request](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.UploadTestCaseResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases/upload#try-it)

Uploads a test case. The content can be a previously downloaded test case. Performs the same function as testCases.create, but accepts input in a string format, which holds the complete representation of the TestCase content.

### HTTP request

`POST https://integrations.googleapis.com/v1/{parent=projects/*/locations/*/integrations/*/versions/*}/testCases:upload`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The test case to upload. Format: projects/{project}/locations/{location}/integrations/{integration}/versions/{integrationVersion} |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "content": string, "fileFormat": enum (`https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/FileFormat`) } ``` |

| Fields ||
|---|---|
| `content` | `string` The textproto of the test case. |
| `fileFormat` | ``enum (`https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/FileFormat`)`` File format for upload request. |

### Response body

Response for testCases.upload.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "testCase": { object (`https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases#TestCase`) } } ``` |

| Fields ||
|---|---|
| `testCase` | ``object (`https://docs.cloud.google.com/application-integration/docs/reference/rest/v1/projects.locations.integrations.versions.testCases#TestCase`)`` The uploaded TestCase |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `integrations.testCases.create`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).